/*
 * ==========================================================================
 *
 *       Filename:  bx_op.h
 *
 *    Description:  header file defines bxOperatorID
 *
 *        Version:  1.0
 *        Created:  09/28/2021 08:48:00 PM
 *       Revision:  none
 *       Compiler:  gcc/g++
 *
 *         Author:  Haoyang Liu (@liuhy), liuhaoyang@pku.edu.cn
 *   Organization:  BICMR, PKU
 *
 * ==========================================================================
 */

#ifndef BALTAM_BX_OP_H
#define BALTAM_BX_OP_H

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    bxUNKNOWN_OP = 0,
    // 双目运算符
    bxADD_OP = 1,
    bxSUB_OP,
    bxTIMES_OP,
    bxRDIV_OP,
    bxLDIV_OP,
    bxMTIMES_OP,
    bxMRDIV_OP,
    bxMLDIV_OP,
    bxPOW_OP,
    bxMPOW_OP,
    bxLT_OP,
    bxGT_OP,
    bxLE_OP,
    bxGE_OP,
    bxNE_OP,
    bxEQ_OP,
    bxAND_OP,
    bxOR_OP,
    bxHCAT_OP,
    bxVCAT_OP,
    // 单目运算符
    bxUMINUS_OP,
    bxUPLUS_OP,
    bxNOT_OP,
    bxTRANSP_OP,
    bxCTRANSP_OP,
    bxSUBSIND_OP
    // 三目运算符
} bxOperatorID;

#ifdef __cplusplus
}
#endif // of __cplusplus

#endif

