/*
 * ==========================================================================
 *
 *       Filename:  extern_fcn_type.h
 *
 *    Description:  headers for declaring external function types
 *
 *        Version:  1.0
 *        Created:  07/29/2021 06:44:27 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Haoyang Liu (@liuhy), liuhaoyang@pku.edu.cn
 *   Organization:  BICMR, PKU
 *
 * ==========================================================================
 */

#ifndef BALTAM_EXTERN_FCN_TYPE_H
#define BALTAM_EXTERN_FCN_TYPE_H

#ifdef __cplusplus
extern "C" {
#endif

struct __bxArray;


// bex 接口函数类型
typedef void (*bexfun_t)(int, struct __bxArray*[], int, const struct __bxArray*[]);
// 复制函数原型
typedef void* (*cstruct_copy_t)(const void*);
// 析构函数原型
typedef void (*cstruct_delete_t)(void*);
// 函数列表元素的结构体
typedef struct {
    const char * name;
    bexfun_t ptr;
    const char * help;
} bexfun_info_t;
// 获取函数列表原型
typedef bexfun_info_t * (*bexfun_list_t)();
// 初始化函数原型
typedef int (*bexinit_t)(int, const struct __bxArray*[]);
// 释放函数原型
typedef int (*bexfini_t)();
// 初始化外部函数库原型
typedef int (*bexinit_lib_t)(void *);


#ifdef __cplusplus
}
#endif

#endif

