/*
 * ==========================================================================
 *
 *       Filename:  test_bex.c
 *
 *    Description:  
 *
 *        Version:  1.0
 *        Created:  06/18/2021 12:40:09 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Haoyang Liu (@liuhy), liuhaoyang@pku.edu.cn
 *   Organization:  BICMR, PKU
 *
 * ==========================================================================
 */

#include <stdio.h>
#include "bex/bex.h"

void bexFunction(int nlhs, bxArray *plhs[], int nrhs, const bxArray *prhs[]){
    if (nlhs != 1){
        fprintf(stderr, "one output argument needed.");
        return;
    }

    if (nrhs != 2){
        fprintf(stderr, "two input arguments are needed.");
        return;
    }

    baSize m = *bxGetPr(prhs[0]);
    baSize n = *bxGetPr(prhs[1]);

    plhs[0] = bxCreateDoubleMatrix(m, n, bxREAL);
    return;
}

