/*
 * ==========================================================================
 *
 *       Filename:  main.c
 *
 *    Description:  source 
 *
 *        Version:  1.0
 *        Created:  06/18/2021 12:50:08 PM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Haoyang Liu (@liuhy), liuhaoyang@pku.edu.cn
 *   Organization:  BICMR, PKU
 *
 * ==========================================================================
 */

#include <dlfcn.h>
#include <stdio.h>
#include "bex/bex.h"

int main(int argc, char **argv){
    void *handle = dlopen("./bex_create.so", RTLD_LAZY);
    if (!handle){
        fprintf(stderr, "读取共享库失败 - %s\n", dlerror());
        return 1;
    }

    bexfun_t fun;
    *(void**)(&fun) = dlsym(handle, "bexFunction");
    if (fun == NULL){
        fprintf(stderr, "无法解析外部符号 - %s\n", dlerror());
        return 1;
    }

    bxArray *plhs[1];
    const bxArray *prhs[2];
    prhs[0] = bxCreateDoubleMatrix(1, 1, bxREAL);
    prhs[1] = bxCreateDoubleMatrix(1, 1, bxREAL);
    double *p1 = bxGetPr(prhs[0]);
    *p1 = 10;
    double *p2 = bxGetPr(prhs[1]);
    *p2 = 5;

    fun(1, plhs, 2, prhs);

    printf("创建了 %ld x %ld 的矩阵\n", bxGetM(plhs[0]), bxGetN(plhs[0]));
    return 0;
}
