function [ p ] = Alg_2_1_Bisection( f, a, b, TOL, N0, flag )
% numerical analysis(9th edition): algorithm 2.1
% input:
%   continuous function f
%   endpoints a,b 
%   tolerance TOL
%   maximum number of iterations N0
%   flag: 1-printf p in each iteration
% output:
%   approximate solution p or message of failure

    n_ite = 1;
    flag_converge_condition = 1;

    if flag_converge_condition==1
       calc_converge_condition = @(p1,p2) abs(p1-p2);
    else     if flag_converge_condition==2
       calc_converge_condition = @(p1,p2) abs(p1-p2)/abs(p2);
    else     if flag_converge_condition==3
       calc_converge_condition = @(p1,p2) abs(f(p2));
    else     if flag_converge_condition==4
       calc_converge_condition = @(p1,p2) abs(p1-p2)/max(abs(p1),abs(p2));
    end
    end
    end
    end
    converge_condition = 2*TOL;
    p1 = 0;
%努力后我们可以去掉这三个小括号
    while  n_ite<=N0  &&   converge_condition>TOL 
        p = (a+b)*.5;
        if flag==1
           fprintf('iteration: %d,\t[a, b] = [%f, %f]\tp: %f,\tf(p): %f\n', n_ite, a, b, p, f(p));
        end
        converge_condition = calc_converge_condition(p1,p);
        p1 = p;
        if converge_condition<TOL
            break;
        end
        if (f(p))*(f(a)) > 0.0
            a = p;
        else
            b = p;
        end
        n_ite = n_ite+1;
    end
    if n_ite>N0
        fprintf('Method failed after N0 iterations, N0 = %d\n',N0);
    end
end
