function [ F_diag ] = Alg_3_2_Newtons_DividedDifference_Formula( x, fx )
% numerical analysis(9th edition): algorithm 3.2
% input:
%   number x = [x0 x1 ... xn]
%   value fx = [f(x0) f(x1) ... f(xn)]
% output:
%   F_diag = [F(0,0) F(1,1) ... F(n,n)]

    n = length(x)-1;
    F = zeros(n+1);
    for i = 1:n+1
        F(i,1) = fx(i);
    end
    for i = 2:n+1
        d = i-1;
        for j = i:n+1
            F(j,i) = (F(j,i-1)-F(j-1,i-1))/(x(j)-x(j-d));
        end
    end
    F
    F_diag = diag(F(2:n+1,2:n+1));
end

