function [ J ] = Alg_4_5_Gaussian_Double_Integral( f, a, b, c, d, m, n )
% numerical analysis(9th edition): algorithm 4.5
% input:
%   function f
%   endpoints x: [a, b]; y: [c(x), d(x)]
%   positive integer m, n
% output:
%   approximation J to I
% 调用举例:
%  Alg_4_5_Gaussian_Double_Integral(@(x,y) x.^2 .*y.^2, 0 , 1, @(x) 0, @(x) 2, 5, 5)

    [n_qpoint_x, qpoint_x, weight_x] = get_Qinfo(n);
    [n_qpoint_y, qpoint_y, weight_y] = get_Qinfo(m);
    
    J = 0;
    for i = 1:n_qpoint_x
        x = (b-a)*qpoint_x(i)/2+(a+b)/2;
        tmp = 0;
        for j = 1:n_qpoint_y
            y = (d(x)-c(x))*qpoint_y(j)/2+(c(x)+d(x))/2;
            tmp = tmp+f(x,y)*weight_y(j);
        end
        J = tmp*(d(x)-c(x))*weight_x(i);
    end
    J = J*(b-a);
end