function M = CMVM(Coord, Elements)
	nnodes = size(Coord,1);
	nelements = size(Elements,1);

	index1 = Elements(:, 1:3) + 1;
	index3 = repmat(index1,1,3);
	index4 = [repmat(index1(:,1),1,3) repmat(index1(:,2),1,3) ...
    repmat(index1(:,3),1,3)];
	ElementArea = .5 * ((Coord(index1(:,2),1) - Coord(index1(:,1),1)) ...
		.* (Coord(index1(:,3),2) - Coord(index1(:,1),2)) ...
		- (Coord(index1(:,2),2) - Coord(index1(:,1),2)) ...
		.* (Coord(index1(:,3),1) - Coord(index1(:,1),1)));
	Omega1 = [Coord(index1(:,2),2) - Coord(index1(:,3),2) ...
		Coord(index1(:,3),1) - Coord(index1(:,2),1)];
	Omega2 = [Coord(index1(:,3),2) - Coord(index1(:,1),2) ...
		Coord(index1(:,1),1) - Coord(index1(:,3),1)];
	Omega3 = [Coord(index1(:,1),2) - Coord(index1(:,2),2) ...
		Coord(index1(:,2),1) - Coord(index1(:,1),1)];

       	entry = (1/4)*[(Omega1(:,1).*Omega1(:,1)+Omega1(:,2).*Omega1(:,2)) ...
	       	(Omega1(:,1).*Omega2(:,1)+Omega1(:,2).*Omega2(:,2)) ...
	       	(Omega1(:,1).*Omega3(:,1)+Omega1(:,2).*Omega3(:,2)) ...
	       	(Omega2(:,1).*Omega1(:,1)+Omega2(:,2).*Omega1(:,2)) ...
	       	(Omega2(:,1).*Omega2(:,1)+Omega2(:,2).*Omega2(:,2)) ...
	       	(Omega2(:,1).*Omega3(:,1)+Omega2(:,2).*Omega3(:,2)) ...
	       	(Omega3(:,1).*Omega1(:,1)+Omega3(:,2).*Omega1(:,2)) ...
	       	(Omega3(:,1).*Omega2(:,1)+Omega3(:,2).*Omega2(:,2)) ...
	       	(Omega3(:,1).*Omega3(:,1)+Omega3(:,2).*Omega3(:,2))];
	entry = diag(1 ./ ElementArea) * entry;
	M = sparse(index3, index4, entry, nnodes, nnodes);

