%%生成质量矩阵
%Coord 节点坐标(x,y)
%Nodes 节点的序号和标记
%Sides 边（这个程序暂时没有用到)
%Elements 单元 第1列到第3列是三角形的三个节点的序号  
function M = CUDU(Coord, Elements)

	nnodes = size(Coord,1);  %节点数  
	nelements = size(Elements,1); %单元数
	index1 = Elements(:,1:3)+1; %单元节点序号, 是一个 nelments x 3 的向量
	index3 = repmat(index1, 3, 1); %把index1复制3份  
	index4 = [index1(:,1)*[1 1 1] index1(:,2)*[1 1 1] index1(:,3)*[1 1 1]];
	%ElementArea是一个向量, 每个分量对应一个单元的面积
	ElementArea = .5 * ((Coord(index1(:,2),1) - Coord(index1(:,1),1)) ...
		.* (Coord(index1(:,3),2) - Coord(index1(:,1),2)) ...
		- (Coord(index1(:,2),2) - Coord(index1(:,1),2)) ...
		.* (Coord(index1(:,3),1) - Coord(index1(:,1),1))) ;
	%在三角形模版单元上积分涉及到 \lambda_i \lambda_j 的积分, i, j = 1,2,3
	%9个数分别是 (1/6)[1 1/2 1/2 1/2 1 1/2 1/2 1/2 1]; 
	entry = (1/6) * ElementArea * [1 1/2 1/2 1/2 1 1/2 1/2 1/2 1];

	%质量矩阵
	M = sparse(index3, index4, entry, nnodes, nnodes);

end


