% LotkaVolterra.m
% 常微分方程组 dx/dt = F(x), 这里给出的就是 F(x) 
% 未知函数 x = [x_1; x_2] 是 t 的函数， 
% x_1(t)是第一个物种的数量 
% x_2(t)是第二个物种的数量 
% d x_1(t) / dt = (r01 -  a12 x_2) x_1;
% d x_2(t) / dt = (r02 -  a21 x_1) x_2;

function [df]=LotkaVolterra(t,x);

x1=x(1);
x2=x(2);

r01 = 1;
a12 = 0.8; 
a21= 0.8;
r02= 1.5;

dx1dt = (r01 - a12*x2).*x1;
dx2dt = (r02 - a21*x1).*x2;

df=[dx1dt ; dx2dt];

end
