%  Monte Carlo 方法计算函数积分
% fh: 要计算函数的句柄, 要求函数是非负有界函数
% x0, x1:  积分的上下界
% fb: 函数的一个上界
% N: 随机点的个数
function s = MonteCarloEx1(fh, x0, x1, fb, N)
x = rand(N,1); 
y = rand(N,1); 
x = linearmap(x, x0, x1); %[0,1]的随机数映射到[x0,x1]
y = linearmap(y, 0, fb); %[0,1]的随机数映射到[0,fb];
fx = fh(x); 
n_accept = sum( y <= fx );  %[0,fb]上的随机数落在[0,fx]之间则接受这个点 
s = n_accept / N * fb*(x1-x0); 

end

% 把[0,1]上的随机数x映射到 [x0,x1]
function y  = linearmap (x, x0,x1) 
  y = x0 + (x1-x0)*x;  
end
