%% author: 赵一菲 
%% email : 1724251313@qq.com
%% 作者简介: 哈尔滨工业大学化工与化学学院

clear;
clc;  
m=0;
load ('py.mat')
[n,p] = size(x);  % n是样本个数，p是指标个数
%这里规定了需要满足n个观测值，每一个观测值有p个指标

% 第一步：计算样本相关系数矩阵
R = corrcoef(x); % R 是pxp的矩阵
disp('样本相关系数矩阵为：')
disp(R)
% 第三步：计算R的特征值和特征向量
% 注意：R是半正定矩阵，所以其特征值不为负数
% R同时是对称矩阵，北太天元不会会将特征值按照从大到小排列哦
% 这里用脚本实现了按照特征值从大到小排序的特征值分解
[V,D] = sort_eig(R);  % V 特征向量矩阵  D 特征值构成的对角矩阵

% 第四步：计算主成分贡献率和累计贡献率
lambda = diag(D);  % diag函数用于得到一个矩阵的主对角线元素值(返回的是列向量)




contribution_rate = lambda / sum(lambda);  % 计算贡献率
cum_contribution_rate = cumsum(lambda)/ sum(lambda);   % 计算累计贡献率  cumsum是求累加值的函数
disp('特征值从大到小排列依次为：')
disp(lambda')  % 转置为行向量，方便展示
%
disp('各自的贡献率为：');
disp(contribution_rate');
%
disp('累计贡献率为：');
disp(cum_contribution_rate');
%
disp('与特征值对应的特征向量矩阵为：');
% 注意：这里的特征向量要和特征值一一对应，之前特征值相当于颠倒过来了，因此特征向量的各列需要颠倒过来
%  rot90函数可以使一个矩阵逆时针旋转90度，然后再转置，就可以实现将矩阵的列颠倒的效果
disp(rot90(V)');

%%
%计算我们所需要的主成分的值
m =input('请输入3需要保存的主成分的个数:  ');

%
F = zeros(n,m);  %初始化保存主成分的矩阵（每一列是一个主成分）
for i = 1:m
    ai = V(:,i)';           
    Ai = repmat(ai,n,1);   % 将这个行向量重复n次，构成一个n*p的矩阵
    F(:, i) = sum(Ai .* x, 2);  % 注意，对标准化的数据求了权重后要计算每一行的和
end
disp('您挑选出的主成分为：');
disp(F)
