%主成分分析的例子, 但是我们把行作为不同的特征，把列数据作为不同观测
function PCAEx2 
% load 函数读入了存入的x矩阵，是17x7的实矩阵
load ('py.mat')
m=0;
x =  x' ;  % 这意味着我们将会有7个特征，17个观测
[p,n] = size(x);  % n是样本个数，p是feature个数
%这里规定了需要满足n个观测值，每一个观测值有p个feature

/*  %开始了多行注释
z = zeros(p,n);
%标准化
for i=1:p
	mu = mean(x(i,:));  % 计算第i个feature的平均值
	sigma = norm(x(i,:) - mu)/sqrt(n);  % 计算第i个feature 的标准差
	z(i,:) = (x(i,:) - mu)/sigma;
end
%多行注释的结尾
*/
z = x;

% 第一步：计算样本相关系数矩阵
%corrcoef 计算的各列之间的相关系数，因此corrceof(z') 计算的是z各行之间的相关系数
R = corrcoef(z'); % R 是pxp的矩阵, 
if isnan(R)
	disp("数据的相关系数为nan")
	return;
end
disp('样本相关系数矩阵为：')
disp(R)
% 第三步：计算R的特征值和特征向量
% 注意：R是半正定矩阵，所以其特征值不为负数
% R同时是对称矩阵，北太天元计算对称矩阵时，不会将特征值按照从大到小排列哦
%[V,D] = eig(R);  % V 特征向量矩阵  D 特征值构成的对角矩阵
% 这里用脚本实现了按照特征值从大到小排序的特征值分解
[V,D] = sort_eig(R)

% 第四步：计算主成分贡献率和累积贡献率
lambda = diag(D);  % diag函数用于得到一个矩阵的主对角线元素值(返回的是列向量)

contribution_rate = lambda / sum(lambda);  % 计算贡献率
cum_contribution_rate = cumsum(lambda)/ sum(lambda);   % 计算累计贡献率  cumsum是求累加值的函数
disp('特征值从大到小排列依次为：')
disp(lambda')  % 转置为行向量，方便展示
%
disp('各自的贡献率为：');
disp(contribution_rate');
%
disp('累计贡献率为：');
disp(cum_contribution_rate');
%
disp('与特征值对应的特征向量矩阵为：');
disp(V);

%%
%计算我们所需要的主成分的值
m =input('请输入3需要保存的主成分的个数:  ');

%
F = V(:,1:m)'*z; %初始化保存主成分的矩阵（每一行是一个主成分）          
disp('您挑选出的主成分为：');
disp(F)

%画出以第一个主成分为横轴，以第二个主成分为纵轴的数据投影图
if m>=2
	clf; close all
	scatter(F(1,:),F(2,:)) 
	text(F(1,:),F(2,:),string(1:n)) 
	set
	xlabel("第一个主成分")
	ylabel("第二个主成分")
end

end
