% 贝叶斯统计的例子
% 某种疾病(例如就说是AIDS)的发病率是 alpha, 
% AIDS病人的血液检验的阳性率是 0.95
% 非AIDS病人的血液检验的阳性率是 0.05
% 血液检验筛查时发现一个人的血液检查是阳性，判断他是AIDS患者的概率
% 是多少
%

alpha = 0.0001:0.0001:0.1
len = length(alpha);
pp = zeros(1,len);
for i=1:len
  a = alpha(i);
  pp(i) = pp_calc(a, 0.95, 0.05); 
end

plot(alpha,pp,'r-*'); 
xlabel('AIDS的发病率')
ylabel('检验阳性时推断是AIDS的概率')

function pp = pp_calc(alpha, apos, bpos)
    pp = alpha * apos / ( alpha *apos + (1-alpha)*bpos); 
end
