%求解谜宫问题 (用BFS算法)
m = 10; n = 10; 
%a = ceil(rand(m,n) > 0.5);

a =  [ 
   0   0   0   1   1   1   0   0   1   1
   1   0   1   1   1   1   0   1   0   1
   1   0   1   0   1   0   0   0   1   0
   1   0   0   1   0   1   0   1   0   1
   1   0   1   0   0   0   0   1   0   0
   1   0   0   0   1   1   0   0   0   1
   1   1   1   1   0   1   1   1   0   0
   1   1   0   0   0   0   1   1   1   0
   1   0   0   1   0   0   1   0   0   0
   0   0   0   1   1   1   0   1   0   1
 ]
  

v = zeros(m,n); 
%v标志数组，
% v(i,j)=0 表示无法从起点到到达(i,j)节点, 
% v(i,j)>=1 表示从起点到达(i,j)点的路径包含的节点数。 
/**
%上面的输入的迷宫，得到的 v 如下, 其中是0，表示不能从起点到达这个地方
%大于0，表示可以到达，显式的数字表示路径中有多少个节点。 
v = [
    3    2    3    0    0    0   15   16    0    0
    0    1    0    0    0    0   14    0    0    0
    0    2    0    0    0   14   13   14    0    0
    0    3    4    0   10    0   12    0   16    0
    0    4    0    8    9   10   11    0   15   16
    0    5    6    7    0    0   12   13   14    0
    0    0    0    0    0    0    0    0   15   16
    0    0    0    0    0    0    0    0    0   17
    0    0    0    0    0    0    0   20   19   18
    0    0    0    0    0    0    0    0   20    0
]
*/

父节点 = zeros(2,m*n+5); %全局定义一个数组 
移动 = [0,0,1,-1 ; 1,-1,0,0]; % 上，下，右，左 的次序

队列 = zeros(2, m*n+5);
头=1; 尾=1;
队列(:, 尾++) = [2;2]; %设置起点是 (2,2) 点
v(2,2)=1;/**< 迷宫起点步数记为1 */
while 头 ~=尾
	xy=队列(:,头++);
	for i=1:4
		next=xy+移动(:,i);  
		%bfs三要素: 合法性, 可访问, 未标记 
		if all(all(next>=1)) && all(all(next<=n)) ... %合法性 
				&& a(next(1),next(2)) == 0  ...  %可访问
				&& v(next(1),next(2)) ==0    %未标记
			v(next(1),next(2)) = v(xy(1),xy(2))+1;%因为(next)是从(xy)走一步到达，因为路径节点数增加1 
		  队列(:,尾++)=next;
			父节点(:, (next(1)-1)*m+ next(2)) = xy; %记录父节点  
		end
	end
end

path = Path(父节点,next,m,n);

clf 
hold off

	if(size(path,2)>1)
		title('路径图'); 
		for j = 1:size(path,2)
			text(path(1,j),path(2,j),['(', num2str(path(1,j)), ',',  ... 
			                num2str(path(2,j)), ')'],'Fontsize',24,'color','r');   %显示节点的坐标  
		    hold on; 
		end
				
		for j=1:size(path,2)-1;
			         x0 = path(1,j); x1=path(1,j+1);
			         y0 =path(2,j); y1 = path(2,j+1);
				line([path(1,j) path(1,j+1)],[path(2,j) path(2,j+1)]);      %连线
				text( (x0+x1)/2,(y0+y1)/2,num2str(j),'Fontsize',30,'color','b');   %显式第几段         
				hold on;
		end  
		hold off;
	end
		
function path = Path(父节点, xy, m,n)
	path = [];
	
	while ~ all(all(xy == 0))
		path = [xy, path];
		xy = 父节点(:,(xy(1)-1)*m+xy(2));		
	end
end		

