% 北太天元上的bootstrap 方法 (自助法, 提升法 )
% 这个方法来自西方古代的神话故事，说是一个人掉进了泥潭，
% 最后靠拉着自己的鞋带把自己拉出了泥潭.

clear all
myStatistic = @mean;

n = 100;        %每个数据集的大小
nReps = 2000;  %重复抽取的次数

x = randn(n,1);
id = ceil(rand(n,nReps)*n);
bootstrapData = x(id);

bootstrapStat = zeros(1,nReps);
for i=1:nReps
    bootstrapStat(i) = myStatistic(bootstrapData(:,i));
end

clf
hist(bootstrapStat,50)  %50 bins
xlabel("均值")
title('北太天元软件上bootstrap应用举例');

%显著性水平
alpha = 0.05;
[muhat_c, sigmahat_c, muci_c, sigmaci_c] = normfit(bootstrapStat ,alpha);

[muhat, sigmahat, muci, sigmaci] = normfit(x,alpha);


disp(sprintf('均值的置信区间长度从 %g 缩短到 %g',muci(2)-muci(1), muci_c(2)-muci_c(1)));
disp(sprintf('标准差的置信区间长度从 %g 缩短到 %g',sigmaci(2)-sigmaci(1), sigmaci_c(2)-sigmaci_c(1)));


