%% 共轭梯度算法
% 求解 Ax = b
clc; clear;
epsilon = 1e-7;
N = 5;
A = rand(N);
%对角占优
for i=1:N
    A(i,i) = A(i,i)+3*(1+rand);
end
A = (A+A')/2; %对称

b = ones(N,1); %右端项

%% 初始化
x = 0;
r = b;
p=r;
rho0 = dot(p,r);

while(rho0 > epsilon)
    w= A*p;
    alpha = rho0/dot(p,w);  %dot(p,w) 是 p与p的 A 内积
    x = x+alpha*p;    
    r = r- alpha*w;
    rho1 = dot(r,r);
    beta = rho1/rho0;
    p = r + beta*p;
    rho0 = rho1;
end

fprintf("共轭梯度法得到的数值解 = ");
for i = 1:length(x)
	fprintf("%6.4f ",x(i));
end
fprintf("\n北太天元内置x=A\b 得到的解 =")
xin = A\b;
for i = 1:length(x)
	fprintf("%6.4f ",xin(i));
end



