% 对一个给定的图，做深度优先搜索
%mat_邻接 : 邻接矩阵 mat_邻接(i,j) = 1 当且仅当 i 和j 连接时
%start : 起始点

%d : d(i) 是节点i被第一次发现时候距离起始节点的距离
%pre : 第一次被发现的节点的列表 (开放).
%post : 最后一次被发现的节点的列表 (关闭).
%cycle : 当且仅当一个(有向)的环被返现，则设置旗标为true
%final : final(i) 是节点结束时的距离起始节点的距离
%前继 : 前继(i) 是 i 的前继节点 

function  [d, pre, post, cycle, final,  前继 ] =  dfsEx1(mat_邻接, start)
	if(nargin == 0 )
		fprintf("至少属于属于一个参数mat_邻接\n")
	 	return;
	end
	if(nargin == 1) 
		start = 1; 
	end
	
	load_plugin("set");
	global white gray black color 时间戳 d final 前继 cycle pre post
	if( size(mat_邻接,1) ~= size(mat_邻接,2) ) 
		fprintf("mat_邻接 必须是方阵\n");
	 	return ;
	end
	n = size(mat_邻接,1); % 节点的个数
	white = 0; gray = 1; black = 2; %节点三种不同的状态
	color = white*ones(1,n);

	时间戳 = 0;

	d = zeros(1,n);
	final = zeros(1,n);

	前继 = zeros(1,n);
	cycle = 0;
	pre = [];
	post = [];

	dfs_visit(start, mat_邻接);

unload_plugin("set");
end

%--------------------------------------------------------------------------
function dfs_visit(u, mat_邻接)
global white gray black color 时间戳 d final 前继 cycle pre post
pre = [pre u];
color(u) = gray;
时间戳 = 时间戳 + 1;
d(u) = 时间戳;
fprintf("目前处理的节点是 u = %4.0f, 标记为灰色\n", u); 

ns = neighbors(mat_邻接, u);
/*
for i = 1:length(ns)
	fprintf("去除前继节点之前: %4.0f 的第 %4.0f 个邻居是 %4.0f\n", u, i, ns(i));
end
*/
ns = setdiff(ns, 前继(u)); % 去掉u的前继节点
/*
for i = 1:length(ns)
	fprintf("去除前继节点之后: %4.0f 的第 %4.0f 个邻居是 %4.0f\n", u, i, ns(i));
end
*/

if(~isempty(ns))
	for v=ns(:)
		switch color(v)
		 case white, % v 还没有被访问过 
			 前继(v)=u;
			 dfs_visit(v, mat_邻接);
		 case gray, % v 已经被访问，但是还没有关闭
			cycle = 1;
		 case black, % v 已经被访问过，而且已经关闭
			%不做任何操作 
		end
	end
end
color(u) = black;
fprintf("节点 u = %4.0f 已经被标记为关闭(黑色)\n", u); 
post = [post u];
时间戳 = 时间戳 + 1;
final(u) = 时间戳;
end
