%Dijkstra 算法 求 最短路径的长度
% for 北太天元数值计算通用软件 

n = 10;  %顶点个数
图矩阵 = zeros(n,n); %邻接矩阵
 
%设置距离
图矩阵 = 100*rand(n,n);
图矩阵 = ceil(图矩阵);
for i=1:n
	图矩阵(i,i) = 0;
end
图矩阵(1,2) = inf;

disp("连接矩阵是")
图矩阵

v0 = 1; %起点
%D最短路径长度
[D] = ShortestPath_DIJ(图矩阵,v0);


for i =1:n
	fprintf("D[%d] = %6.4f\n",i,D(i));
end

% 计算连接矩阵图矩阵 的v0节点到其他节点的最短距离和路径，
% 图矩阵： 连接矩阵 图矩阵(i,j) 表示从i到j的距离
% v0:  起点
% D: 最短距离
function  [D] = ShortestPath_DIJ(图矩阵,v0)
	n = size(图矩阵,1);
	D = 图矩阵(v0,:);
	final = zeros(n,1); %若final[i] = 1则说明 顶点vi已在集合S中

	D(v0) = 0; final(v0)=1; %初始化 v0顶点属于集合S
	  %开始主循环 每次求得v0到某个顶点v的最短路径 并加v到集合S中
	 for i = 2:n
		min_iv = inf;  %min_iv 将会存放在第i次选择的 节点v 的距离 
		%(第i次选择时与v0的之间具有最短路径的点v)
		%核心过程--选点
		for w=1:n
			if ~final(w)  %如果w不在集合S中
				if D(w) < min_iv 
					v = w; min_iv = D(w);
				end
			end
		end	
		final(v) = 1; %选出该点后加入到集合S中
		for w = 1:n   %更新当前最短路径和距离
			%在此循环中 v为当前刚选入集合S中的点
			%更新以v作为中间点的各个节点距离起点的距离(可能会更短)
			if ~final(w) && min_iv+图矩阵(v,w)<D(w)
				D(w) = min_iv + 图矩阵(v,w);
			end 
		end
	end 
end

