%Dijkstra 算法 求 最短路径
% 增加了路由 和  最短路径的输出
% for 北太天元数值计算通用软件 

n = 4;  %顶点个数
图矩阵 = zeros(n,n); %邻接矩阵
 
%设置距离
图矩阵 = 100*rand(n,n);
图矩阵 = ceil(图矩阵);
for i=1:n
	图矩阵(i,i) = 0;
end
图矩阵(1,2) = inf;

disp("连接矩阵是")
图矩阵
/* 例如
图矩阵 = [  
    0.0000       inf   28.0000   40.0000
   85.0000    0.0000   48.0000   84.0000
   86.0000   30.0000    0.0000   34.0000
   85.0000    6.0000   48.0000    0.0000
	 ]
*/

v0 = 1; %起点
%D最短路径长度
[D,p] = ShortestPath_DIJ(图矩阵,v0);
for i =1:n
	fprintf("D[%d] = %6.4f\n",i,D(i));
end

%打印出vj 与 v0 之间的路由
vj = 2; 
if(D(vj) == inf) 
	fprintf("%d %d 之间没有路径", v0,vj);
else
	fprintf("%d %d 之间的最短路径:\n", v0,vj);

	% 从vj 回溯 到v0节点，得到从v0到vj的路径
	% 例如得到的 p=[1,4,1,1] 
	% v0 = 1; vj =2; 
	% 那么我们回溯的过程
	% 首先 path =[ 2], 然后看到 p[2]  是4， 我们知道最短路径连接2的是节点4，
	% 于是path 变成了 path = [ 2, 4 ], 然后看到 p[4] = 1, 
	% 于是 path 变成了 path = [ 2, 4, 1], 因为此时 path(end) == v0 
	% 于是最短路径上的节点全部找到了. 
	% 然后通过 path = path(end:-1:1) 进行了逆序排列得到了 path = [1,2,4];
	path = vj;
	while path(end) ~= v0
		path = [path, p(path(end))]; 
	end
	path = path(end:-1:1);

	%打印出路径 
	for i=1:length(path);
		fprintf(" %d ", path(i));
		if i ~= length(path)
			fprintf(" --> ");
		end
	end
end

% 计算连接矩阵图矩阵 的v0节点到其他节点的最短距离和路径，
% 图矩阵： 连接矩阵 图矩阵(i,j) 表示从i到j的距离
% v0:  起点
% D: 最短距离
% p: 路由
function  [D,p] = ShortestPath_DIJ(图矩阵,v0)
	n = size(图矩阵,1);
	D = 图矩阵(v0,:);
	final = zeros(n,1); %若final[i] = 1则说明 顶点vi已在集合S中

	D(v0) = 0; final(v0)=1; %初始化 v0顶点属于集合S
	  %开始主循环 每次求得v0到某个顶点v的最短路径 并加v到集合S中

	p = v0*(ones(1,n)-(D == inf)); % 如果j和v0之间的距离是无穷，则p(j) = 0; 不然则是v0;

	 for i = 2:n
		min_iv = inf;  %min_iv 将会存放在第i次选择的 节点v 的距离 
		%(第i次选择时与v0的之间具有最短路径的点v)
		%核心过程--选点
		for w=1:n
			if ~final(w)  %如果w不在集合S中
				if D(w) < min_iv 
					v = w; min_iv = D(w);
				end
			end
		end	
		final(v) = 1; %选出该点后加入到集合S中
		for w = 1:n   %更新当前最短路径和距离
			%在此循环中 v为当前刚选入集合S中的点
			%更新以v作为中间点的各个节点距离起点的距离(可能会更短)
			if ~final(w) && min_iv+图矩阵(v,w)<D(w)
				D(w) = min_iv + 图矩阵(v,w);
				p(w) = v;
			end 
		end
	end 
end

