clc; clf; close all; clear all; 
% easymesh 是一个free的网格剖分程序，可以把它加入北大天元
% 做成插件, 然后从北大天元调用。
load_plugin("easymesh")
% 四个点的坐标分别是 (0,0), (1,0), (1,1), (0,1)
points_part1 = [ 0 0 ;  1 0;  1 1 ;  0 1 ] ;
points_part2 =  ones(size(points_part1))*0.3 + 0.2*points_part1; 
points = [ points_part1 ; points_part2];
%四个边, 
% edges 是 4x2的矩阵，
% 第一行: 0 1 表示从第一个点(0,0)指向第二个点(1,0)的一条边
% 第二行: 1 2 表示从第二个点(1,0)指向第三个点(1,1)的一条边
edges_part1 = [ 0  1;  1  2; 2 3 ; 3 0 ] ;  %逆时针的闭合曲线
edges_part2 = 4 + [ 0  1;  1  2; 2 3 ; 3 0 ] ;  
%中间形成一个洞，边需要按照顺时针顺序排列
edges_part2 = edges_part2(end:-1:1, :) ; % 这一步也不能少 
edges_part2 = edges_part2(:, end:-1:1) ; % edges_parts2 是顺时针的闭合曲线
%两部分边和在一起
edges = [edges_part1; edges_part2] ;
[np,~] = size(points);  %点的个数
[ns,~] = size(edges);  %边的个数
%每个点附近网格大小的参数，这里都设置为 0.1
nodes_F = 0.1*ones(np,1);
%点的标志，这里都设置为 1
nodes_mark = ones(np,1);
%边的标志，这里都设置为 1
edges_mark = ones(ns,1);
%剖分网格，生成的网格保存在第一个参数知名的三个文件中
%分别是 example4.n , example4.s, example4.e 分别存储的是点，边和单元的信息
[mesh_nodes,mesh_elements,mesh_sides]  = easymesh2d("example4", points, edges, nodes_F, nodes_mark, edges_mark);

%返回的单元 mesh_elements 是 nele x 3 的矩阵，每行的3个元素是单元的节点编号(从0开始编号)
%返回的单元 side_elements 是 nside x 2 的矩阵，每行的2个元素是边的节点编号(从0开始编号)
[nside, ~] = size(mesh_sides); 
hold on
for i=1:nside;
	line( ... 
		[ mesh_nodes(mesh_sides(i,1)+1,1), mesh_nodes(mesh_sides(i,2)+1,1)] , ...
		[ mesh_nodes(mesh_sides(i,1)+1,2), mesh_nodes(mesh_sides(i,2)+1,2)] ) 
end 
hold off

