%EM算法的一个迭代
function [t1_new, t2_new]=emEx1(height,t1_old,t2_old)

%Step 1. 
%计算给定身高是属于男生的后验概率R1 和 属于女生的后验概率R2
N = length(height);
p1 = t1_old.w*pdf('norm', height, t1_old.mu, t1_old.sigma);
p2 = t2_old.w*pdf('norm', height, t2_old.mu, t2_old.sigma);
R1 = p1 ./ (p1+p2); %身高p1(i)是男生的身高的后验概率是R1(i)
R2 = p2 ./ (p1+p2); %身高p1(i)是女生的身高的后验概率是R2(i)

%Step 2. 计算男女生的总人数 (注意可能是分数啊，这是一个概率)
s1 = sum(R1); 
s2 = sum(R2); 

%Step 3.
%更新男、女生身高分布的期望mu
t1_new.mu = dot(R1, height)/s1;
t2_new.mu = dot(R2, height)/s2;

%Step 4.
%更新男、女生身高分布的标准差sigma(一维）
t1_new.sigma = sqrt( dot(R1, (height-t1_new.mu).^2) / s1 );
t2_new.sigma = sqrt( dot(R2, (height-t2_new.mu).^2) / s2 );

%Step 5.
%更新权值
t1_new.w = s1/N;
t2_new.w = s2/N;

end  %end for emEx1函数

function y = pdf(name, x, mu, sigma)
  if (~strcmpi(name,'norm'))
    error("name 需要是 'norm'");
  end 
  if sigma <= 0
    error("sigma 需要需要大于 0");
  end
  y = 1/sqrt(2*pi)/sigma * exp( - (x-mu).^2 ./ (2*sigma.^2) ); 
end  
