clc; clf; close all; clear all; 
%加载生成三角形网格插件easymesh
load_plugin("easymesh")
% 四个点的坐标分别是 (0,0), (1,0), (1,1), (0,1)
points = [ 0 0 ;  1 0;  1 1 ;  0 1 ] ;
%四个边, 
% edges 是 4x2的矩阵，
% 第一行: 0 1 表示从第一个点(0,0)指向第二个点(1,0)的一条边
% 第二行: 1 2 表示从第二个点(1,0)指向第三个点(1,1)的一条边
edges = [ 0  1;  1  2; 2 3 ; 3 0 ] ;  %逆时针的闭合曲线
[np,~] = size(points);  %点的个数
[ns,~] = size(edges);  %边的个数
%每个点附近网格大小的参数，这里都设置为 0.1
nodes_F = 0.25*ones(np,1);
%点的标志，设置 1
nodes_mark(1:4) = 1; 
%边的标志，设置 1 
edges_mark(1:4) = 1;

%剖分网格，生成的网格保存在第一个参数同名的三个文件中
%分别是 .n , .s, .e 分别存储的是点，边和单元的信息
[mesh_coords,mesh_elements,mesh_sides,mesh_nodes_mark,mesh_sides_mark] ...
 	= easymesh2d("genMeshEx1", points, edges, nodes_F, nodes_mark, edges_mark);

unload_plugin("easymesh");

%返回的单元 mesh_elements 是 nele x 3 的矩阵，每行的3个元素是单元的节点编号(从0开始编号)
%返回的单元 side_elements 是 nside x 2 的矩阵，每行的2个元素是边的节点编号(从0开始编号)

S = CUDU(mesh_coords, mesh_elements);
M = CMVM(mesh_coords, mesh_elements);

%右端项 
% f(x,y) = x*y; 
ff = 10 + mesh_coords(:,1) .* mesh_coords(:,2);


%%内部节点
JJ = ( mesh_nodes_mark == 0 );
%%刚度矩阵对应于内部节点的部分
fM = full(M); 
AA = fM(JJ,JJ);
%%边界节点
BB = ( mesh_nodes_mark ~= 0 );
AB = fM(JJ,BB); 

%% 边界值
BB_index = 1:size(mesh_coords,1); 
BB_index = BB_index(BB);
%边值函数 x+y
ub = mesh_coords(BB_index,1)+mesh_coords(BB_index,2); 

FS = full(S);
ux =AA\(FS(JJ,:)*ff - AB*ub);

u = zeros(size(mesh_coords,1),1); 
u(JJ) = ux; 
u(BB) = ub; 

scatter3(mesh_coords(:,1), mesh_coords(:,2), u);
