% Floyd算法求给定的加权图中多源点之间最短路径
% 输入参数A: 邻接矩矩
% 输入参数 p_起点: 
% 输入参数 p_终点: 
% 输出参数 d_距离: 最短路径的长度
% 输出参数 s_路径: 最短路径的节点数组
function [d_距离, s_路径]=floydEx1(A,p_起点,p_终点);
n=size(A,1);
r_路由=zeros(n); 
for k=1:n
	for i=1:n
		for j=1:n
			if A(i,j)>A(i,k)+A(k,j)
				A(i,j)=A(i,k)+A(k,j);
				r_路由(i,j)=k;
			end
		end
	end
end
d_距离=A(p_起点,p_终点);
pr=r_路由(p_起点,:);%从 p_起点 到 其它各点的最短路径的前驱节点 
pr(pr==0)=p_起点;% r_路由 分量为0表示该顶点是起点

%回溯路由得到从 p_起点 到 p_终点 的路径
s_路径=p_终点;
t = p_终点;
while t ~= p_起点
	p=pr(t);
  s_路径=[p,s_路径];
	t=p;
end
