%% 一维热传导方程的例子
%% 有限差分方法

% u_t - k u_xx =0 ,  x \in [0, 1], t\in (T_起点,T_终点];    
% u(t,0) = T_左 ;  t\in (T_起点,T_终点];
% u(t,1) = T_右;   t\in (T_起点,T_终点];
% u(t_起点,x) = sin(\pi*x)+ T_左  + (T_右 - T_左) *x, x\in[0,1]

clear all; close all; clc; 
load_plugin("time");

k = 1; %传导率
h = 0.02; 
n = floor(1 / h )+1; %假设所得到的网格大小就是h了
x = linspace(0,1,n);
T_左 = 0; T_右 = 2; 
初值 = sin(pi*x) + T_左 + (T_右-T_左)*x; 

%时间步长
dt = h*h / (4*k); 

% k dt / h^2
c = k *dt / (h*h);

%显式格式 
t_起点 = 0 ; 
t_终点 = 1 ; 
nt = floor((t_终点-t_起点)/dt )+1;
t_终点 = t_起点 + nt*dt ;  %真正计算的终点时刻

u =  初值;

nx = length(x);
for it = 1:nt
	for j=2:nx-1
		u(j)  = u(j) + c * ( u(j-1)  -2*u(j)  + u(j+1) ); 
	end

	if(mod(it,100) == 1) 
		plot(x, u)
		xlabel("x");
		ylabel("u");
		title(sprintf("t=%6.3f",t_起点+it*dt)); 
		pause(0.02);
		if(mod(it,1000) == 1)
			s = input("input a number 0 to stop or other number to continue:  ");
			if s == 0 
				break;
			end
		end
	end
end

