%x,y 是给定的插值点，利用分片线性插值
%求 xx 点的函数值
%假设 x 是一个向量 x =[ x1, x2, ..., xn] 
% xi \neq xj  if i \neq j
% y 也是一个向量，长度和 x 相同
% 返回一个函数句柄，提供一个分片线性插值函数
% 
function yy = interp1Ex1( x, y , xx) 
	n = length(x);
	len = length(xx);
	yy = zeros(size(xx));

	for j=1:len;
		xxj = xx(j);
		if xxj < x(1)
			yy(j) = y(1); 
		elseif xxj >= x(n) 
			yy(j) = y(n);
		else 
			k = find(x==xxj);
			%如果没有找到返回的是一个空logic矩阵，因此使用是否非空来判断是否找到
			if ~isempty(k) 
				yy(j) = y(k(1));
				continue;
			else
				k = find(x> xxj, 1);
				yy(j) = y(k-1) + (y(k)-y(k-1))*(xxj-x(k-1))/(x(k)-x(k-1)); 
			end
	end
end
