% 来源 https://zhuanlan.zhihu.com/p/386670331
function K = kernels(X1, X2, kernel_type)
%计算核函数
ind = 0;  
if strcmpi(kernel_type, 'linear') 
  ind = 0; 
elseif strcmpi(kernel_type, 'polynomial')
  ind = 1; 
else strcmpi(kernel_type, 'rbf')
  ind = 2; 
end

switch ind    
   %线性核函数
    case 0 
        K = (X1' * X2);
   %多项式核函数，这里设置的3次核函数
    case 1 
        K = (X1' * X2).^3;
   %RBF核函数，需要设置核函数的带宽
    case 2    
        K=zeros(size(X1,2),size(X2,2));
        for m=1:size(X1,2)
            for n=1:size(X2,2)
                K(m,n)=exp(-sum((X1(:,m)-X2(:,n)).^2)/0.345);%这里设置的核带宽σ=0.345
            end
        end
          
end

end
