function 准确率 = knnEx1(训练数据特征, 验证数据特征, 训练数据标签, 验证数据标签, k)
    预测标签准确总数 = 0;
    for i = 1:size(验证数据特征, 1)
				%计算第i个验证数据特征和各个训练数据特征的之间的距离
        D = 验证数据特征(i, :) - 训练数据特征; 
        %这里验证数据特征(i,:)只有一行, 训练数据特征有多行
        % 二者的列数相等，这样的减法是允许的
        % 例如 [ 1 2 ] - [ 1 2; 
				%                  3, 4 ] 
				% 得到 [ 0 0 ; 
				% 2 , 3 ] 
        D = D.^2;
        距离 = sum(D, 2);  %sum(D,2) 沿着行求和
        距离 = sqrt(距离);  
        距离和标签 = [距离 训练数据标签]; 
        %距离和标签 是两列的矩阵, 第一列是第i个测试数据和所有训练数据的距离
        % 第二列是训练数据的标签

				%按照距离从小到大排序, 设置前k个距离最小之中标签出现最多为预测标签
        距离和标签 = sortrowsEx1(距离和标签, 1); % 
				k_近邻 = 距离和标签(1:k, :); %取得 k 个最近的邻居           
				预测标签 = modeEx1(k_近邻(:, 2));
				真实标签 = 验证数据标签(i, 1);
				if 真实标签 == 预测标签
					预测标签准确总数 = 预测标签准确总数 + 1;
					fprintf('序号=%5d, 预测准确: 标签=%3d \n', i, 预测标签);
				else
					fprintf('序号=%5d, 预测错误: 预测标签=%3d, 真实标签=%3d \n', i, 预测标签, 真实标签);
				end
    end
    
		准确率 = 预测标签准确总数/size(验证数据标签, 1);
end

