%logistic map 例子
% x_{n+1} = mu x_n (1-x_n)
% 根据 mu 的不同，迭代的不动点不同

clear all; close all; clf; clc
mu_min = 2;
mu_max = 4; 
mu_step = 0.02;

hold on

for mu = mu_min : mu_step : mu_max

	x= 0.5; %  初值
	iters = 1000; %不进行输出的迭代步数
	last = 100; %最后画出结果的迭代步数
	xi = zeros(last,1);
	for i = 1: (iters+last)
		x = mu*x*(1-x);
		if i > iters
			xi(i-iters,1) = x ;
		end
	end
	plot(mu*ones(last,1), xi, 'k*');
end

hold off

