%做个动画来画Lorenz 方程的 解， 
clc;  clf;  close all; clear all;

/* Edward Lorenz美国气象学家
Lorenz equation
dx/dt = sigma*(y-x)
dy/dt = x(rho-z)-y
dz/dt = xy - beta*z
这是一个非线性的方程组 for x(t),y(t),z(t)
sigam,rho,beta 是三个参数 
w =[x;y;z]
w 是 \mathbb{R}^3中的元素，有三个分量, 给出Lorenz方程的初值
  [t_begin, t_end]
*/

参数_sigma = 10; 参数_rho = 28; 参数_beta = 3;
% 计算出 dx/dt, dy/dt, dz/dt 的值
odefun = @(t,w) [参数_sigma*(w(2)-w(1)); 
  w(1)*(参数_rho-w(3))-w(2); 
  w(1)*w(2)-参数_beta*w(3)];

t_起点 = 0; t_终点 = 30;
n = 101; 
时间点 = linspace(t_起点, t_终点, n); 

初值1 = [0.0, 1.00, 0.0]; 
初值2 = [0.0, 1.01, 0.0]; 
for i=1:n-1
  tspan = [时间点(i)  时间点(i+1)];
  options = odeset('RelTol', 1e-3, 'AbsTol', 1e-5); 
  % 调用ode 对lorenz 进行求解, 用两个不同的初始值
  [t1 y1] = ode45(odefun, tspan, 初值1, options);
  [t2 y2] = ode45(odefun, tspan, 初值2, options);
  初值1 = y1(end,:);
  初值2 = y2(end,:);
  %绘图
  hold on 
  plot3(y1(:,1),y1(:,2),y1(:,3), 'r-', 'LineWidth', 2);
  plot3(y2(:,1),y2(:,2),y2(:,3), 'b-', 'LineWidth', 2);
end

