% logistic regression 逻辑回归的例子
% 数据有三列
% 语文、数学、是否被录取
% 例如 lrEx1data.txt 的数据如下
% 最后得到的是一个匿名函数表达的决策函数
%更多的注释见 lrEx2.m
% 这的目标函数从表达式看更加简洁，但是从计算效果来看并没有lrEx2.m 好
/*
100 100 1
90 90 1
80 80 1
98 75 1
25 38 0 
28 32 0 
27 33 0 
22 33 0 
*/

[pre, t] = logistic_regression('lrEx1data.txt');
x1=30:100;
plot(x1,(-t(1)-t(2)*x1)/t(3),'LineWidth',2); %决策边界
legend('决策边界')
%画出决策边界:
% x1 语文, x2 数学, t(1)+x1*t(2)+x2*t(2) = 0 是决策边界 
% 也就是直线 x2 = (-t(1)x1 - t(2) )/t(3)
hold on
data=readmatrix('lrEx1Data.txt');
T = data( data(:,3) == 1, 1:2); %被录取的成绩
F = data( data(:,3) == 0, 1:2); %未被录取的成绩 
scatter(T(:,1),T(:,2),100,'b');
scatter(F(:,1),F(:,2),100,'r');
title('蓝点是被录取的成绩，红点是未被录取的成绩')
xlabel('语文成绩')
ylabel('数学成绩')
hold off

function [pre, t] = logistic_regression(datafile)
data=readmatrix('lrEx1Data.txt');
%用fminsearch函数最优化
%logistic=@(t)((1.+exp(-(t(1)+dot(t(2:3),x)))).^-1)
n=length(data(:,1)); %学生数
% 这里对所有的i求和，但是利用标签是0时，求和中的第一项恰好是0，标签是1时，求和中的第二项恰好是0
s=@(t) -sum( ... 
  data(:,3) ... 
    .* log((1.+exp(-(t(1)+data(:,1)*t(2)+data(:,2)*t(3)))).^-1) ... 
   + (1-data(:,3)) ...
  .*log(1-(1.+exp(-1*(t(1)+data(:,1)*t(2)+data(:,2)*t(3)))).^-1))/n;
[t,fval] = fminsearch(s,[0,0,0]) %以初值t=[0,0,0]求函数s的最小值点

%prediction 预测
pre=@(x)(1+exp(-1*(t(1)+t(2)*x(1)+t(3)*x(2))))^-1;
t
end
