% mesh2d 是一个二维网格剖分程序
load_plugin("mesh")
% 四个点的坐标分别是 (0,0), (1,0), (1,1), (0,1)
points = [ 0 0 ;  1 0;  1 1 ;  0 1 ] ;
%四个边, 
% edges 是 4x2的矩阵，
% 第一行: 0 1 表示从第一个点(0,0)指向第二个点(1,0)的一条边
% 第二行: 1 2 表示从第二个点(1,0)指向第三个点(1,1)的一条边
edges = [ 0  1;  1  2; 2 3 ; 3 0 ] ; 
[np,~] = size(points);  %点的个数
[ns,~] = size(edges);  %边的个数
%每个点附近网格大小的参数，这里都设置为 0.1
nodes_F = 0.1*ones(np,1);
%点的标志，这里都设置为 1
nodes_mark = ones(np,1);
%边的标志，这里都设置为 1
edges_mark = ones(ns,1);
%剖分网格，生成的网格的节点坐标保存在mesh_coords, 单元保存在mesh_elements
[mesh_coords, mesh_elements] = mesh2d("general2d", points, edges, nodes_F, nodes_mark, edges_mark)

Coord = mesh_coords;
Element = mesh_elements;
XXX = zeros(6*size(Element,1), 2);
clf; close all;
hold on
for i=1:size(Element,1)
	L = ... 
		[ Coord(Element(i,1)+1,:);Coord(Element(i,2)+1,:)
		Coord(Element(i,2)+1,:);Coord(Element(i,3)+1,:)  
		Coord(Element(i,3)+1,:);Coord(Element(i,1)+1,:)  
		];
		line(L(:,1),L(:,2));
end
hold off
title("剖分成三角形");
unload_plugin("mesh")


