%是网格剖分插件mesh
load_plugin("mesh")
% 四个点的坐标分别是 (0,0), (1,0), (1,1), (0,1)
points_part1 = [ 0 0 ;  1 0;  1 1 ;  0 1 ] ;
points_part2 =  ones(size(points_part1))*0.3 + 0.2*points_part1; 
points = [ points_part1 ; points_part2];
%四个边, 
% edges 是 4x2的矩阵，
% 第一行: 0 1 表示从第一个点(0,0)指向第二个点(1,0)的一条边
% 第二行: 1 2 表示从第二个点(1,0)指向第三个点(1,1)的一条边
edges_part1 = [ 0  1;  1  2; 2 3 ; 3 0 ] ;  %逆时针的闭合曲线
edges_part2 = 4 + [ 0  1;  1  2; 2 3 ; 3 0 ] ;  
%中间形成一个洞，边需要按照顺时针顺序排列
edges_part2 = edges_part2(end:-1:1, :) ; % 这一步也不能少 
edges_part2 = edges_part2(:, end:-1:1) ; % edges_parts2 是顺时针的闭合曲线
%两部分边和在一起
edges = [edges_part1; edges_part2] ;
[np,~] = size(points);  %点的个数
[ns,~] = size(edges);  %边的个数
%每个点附近网格大小的参数，这里都设置为 0.1
nodes_F = 0.1*ones(np,1);
%点的标志，这里都设置为 1
nodes_mark = ones(np,1);
%边的标志，这里都设置为 1
edges_mark = ones(ns,1);
%剖分网格，生成的网格的节点和单元保存在 mesh_coords 和 mesh_elements 
[mesh_coords, mesh_elements] = mesh2d("example3", points, edges, nodes_F, nodes_mark, edges_mark)
