function y = mychar(varargin)
%check input arguments
if(nargin <1 || nargin > 5)
  disp("演示我们可以调用系统的char函数来处理多个输入参数的情形")
  disp("但是，在我们这里对输入的总参数限制为1-5之间")
  disp("例: mychar([99,100,101], \"99\", ['I love ', 'you, ', 'China!'])")
  disp("你copy上面命令的时候，请把引号前的反斜杠去掉")
  return 
end
%获得用户命令输入的参数的个数
m = length(varargin);
% 还需要检查每一个参数是不是行向量
for ind =1:m
[r,~]=size(varargin{1});
if(r != 1) 
  disp(['第' num2str(ind) '个参数不是行向量']);
  disp("每个参数都需要是行向量")
  return
end
end

%还可以对每个参数的类型进行检查


%计算转换所得字符串的最大长度
n = length(char(varargin{1}));
for ind=2:m
  n = max(n, length(char(varargin{ind})));
end
%如何声明一个mxn 的char矩阵? 我只好先声明一个mxn double矩阵，
% 然后转成mxn char 矩阵
y = ones(m,n); 
y = char(y);
for i=1:m
  c = char(varargin{i});
  for j=1:length(c)
    y(i,j) = c(j);
  end
end
end



