%用Newton法求函数f的根
% fh: 函数句柄
% gh: 导数句柄
% x0: 初值
% ep: 误差
% Nm: 最大迭代步数
% 例如
% x = newtonEx2(@sin, @cos, 1, 0.01, 100);
function  x1 = newtonEx2(fh, gh,  x0, ep, Nm)
if (nargin <2)
	error("至少要输入一个函数句柄 和 该函数的导数句柄");
	return; 
end
if nargin < 3
	x0=input('请输入初值: x0=');
elseif nargin < 4
	ep=input('容忍误差上界: ep=');
elseif nargin < 5 
	Nm=input('请输入最大迭代步数: Nm=');
end
k=0;
x1 = x0;
while  1 
  fprintf("k=%.0f,x=%.10f\n",k,x0);  
  k=k+1;
	x1=x0-fh(x0)/gh(x0);
	if abs(x1-x0) < ep  || k>=Nm 
		break;
	end
	x0 = x1;
end
fprintf("k=%.0f, x=%.10f\n", k, x1);
if k==Nm 
  warning('k超出预设值');
end

end

