% 利用erf函数求正态分布函数的累积分布函数 cdf
% 正态分布函数的分布函数 \phi(x) = \frac{1}{\sqrt{2\pi}\sigma} 
%                   \int_{-\infty}^{x} exp( -\frac{(t-mu)^2}{2\sigma} ) d t
% mu: 正态分布的矩阵
% sigma: 正态分布的根方差
function y = normcdf(x,mu,sigma)
	if(nargin == 1)
		mu = 0;
		sigma =1;
	end
	y = 1/2+1/2*erf( (x-mu)/(sqrt(2)*sigma) );
end

