% 利用erf函数求正态分布函数的 cdf 的逆
% 正态分布函数的分布函数 \phi(x) = \frac{1}{\sqrt{2\pi}\sigma} 
% \int_{-\infty}^{x} exp( -\frac{(t-\mu)^2}{2\sigma^2} ) d t
% 可以通过 erfinv 来求\phi(x) 的逆 norminf
% mu: 正态分布的矩阵
% sigma: 正态分布的根方差
% 

function y = norminv(x,mu,sigma)
	if(nargin == 1)
		mu = 0;
		sigma =1;
	end
	y =  (erfinv( 2*(x - 1/2) )   + mu) * sqrt(2)*sigma;
end

