% normpdf函数 
% 用法:
% Y = normpdf % X = -4:0.1:4 ; mu = 0 , sigma = 1; 
% Y = normpdf(X,mu,sigma)
% Y = normpdf(X) %  (mu = 0, sigma = 1)
% Y = normpdf(X,mu) % (sigma = 1)

function y = normpdf(x, mu, sigma)
	if nargin < 1 
		x = -4:0.1:4;
	end

	if nargin < 2 
		mu = 0; 
	end

	if nargin < 3 
		sigma = 1.0;
	end

  if sigma <= 0 || numel(sigma) ~=1 
    error("sigma 需要需要大于0的标量");
  end

	if numel(mu) ~= 1
    error("mu 需要需要是标量");
	end

  y = ( 1/sqrt(2*pi)/sigma ) * exp( - (x-mu).^2 ./ (2*sigma.^2) ); 
end  

