%Planck's law of radiation 
%Raleigh-Jeans 
%Wein 
% 三个公式都是给出黑体辐射强度对频率和温度的依赖关系
% 我们先固定温度T

%引入 y = \frac{c^3 h^2}{8\pi (k_B T)^3} I,  其中I是辐射强度，c 是光速, 
% h 是普朗克常数, k_B 是玻尔兹曼常数, T 是温度
%引入 x = \frac{h \nu}{k_B T} , where h is planck's constant, 
% \nu is frequency, k_B is Boltzmann's constant, and T is temperature
%

x = 0.01:0.01:5;

%Raleigh-Jeans
y_r = x.^2;

%Wein
y_w =  x.^3 ./ exp(x) ; 

%Planck
y_p = x.^3 ./ ( exp(x) - 1.0 );

ind_r = find(y_r < 5);

plot(x(ind_r),y_r(ind_r),'LineWidth',3, x,y_w, 'LineWidth',3, x, y_p, 'LineWidth', 3);
%plot(x,y_r,'LineWidth',3, x,y_w, 'LineWidth',3, x, y_p, 'LineWidth', 3);
legend('Reighley-Jean', 'Wein', 'Planck')
title("黑体辐射的三个公式")
xlabel("无量纲频率")
ylabel("无量纲辐射强度")
