% 用数值积分计算gini coefficient(基尼系数)
% 假设我们已经获得了一个估计的收入的数据
% 把人口按照从低收入到高收入排序
% 0% 的人收入占全部收入的 0% (这个总是如此啊)
% 10% 的人收入占全部收入的 %2, 
% 20% 的人收入占全部收入的 %8, 
% 30% 的人收入占全部收入的 %20, 
% 40% 的人收入占全部收入的 %25, 
% 50% 的人收入占全部收入的 %30, 
% 50% 的人收入占全部收入的 %40, 
% 70% 的人收入占全部收入的 %50, 
% 80% 的人收入占全部收入的 %60, 
% 90% 的人收入占全部收入的 %70, 
% 100% 的人收入占全部收入的 %100 

x = 0:0.1:1;  %人口比例
y = [0, 0.02, 0.08, 0.20, 0.25, 0.30, 0.40, 0.50, 0.60, 0.70, 1] ;

%使用复合梯形积分公式计算 [x,y] 曲线下的面积
B = 0.0;
len = length(x);

if(len < 2)
	disp("x的长度必须大于2");
	return;
end

B = 0;
for i = 1:len-1
	B = B + 0.5*(y(i)+y(i+1))*(x(i+1)-x(i))
end

%基尼系数 G = (1/2-B)/(A+B)
G = 2*(1/2-B)

