% 求 ax^2+bx+c=0 的根， 要求 a,b,c 都是实标量
function [x1,x2] = root_abc(a,b,c)

	if( nargin ~= 3) 
		disp("root_abc 需要3个输入参数")
		return;
	end

	if  (~isreal(a))||(~isscalar(a)) 
		disp(" a is not real or is not scalar ")
		return;
	end
	if  (~isreal(b))||(~isscalar(b)) 
		disp(" b is not real or is not scalar ")
		return;
	end

	if  (~isreal(c))||(~isscalar(c)) 
		disp(" c is not real or is not scalar ")
		return;
	end

	if(a == 0) 
		disp(" this is not 一元二次方程")
		return;
	end

	delta = b.^2 - 4*a*c ;

	if(delta < 0) 
		disp(" no solution");
		return;
	end

%	x1 = ( - b + sqrt(delta) )/(2*a) ; 
%	x2 = ( - b - sqrt(delta) )/(2*a) ; 
	
	x1 = -2*c/(  b + sqrt(delta) ) ; 
	x2 = ( - b - sqrt(delta) )/(2*a) ; 

end
