% 特殊函数 erf 函数
% erf(x)= \frac{2}{\sqrt{\pi}} \int_{0}^{x} exp(-t^2) d t 
% 积分下限是0，上限是x. 
% 误差函数从形式上很像正态分布的分布函数 \phi(x)
% 标准正态分布函数的分布函数 \phi(x) = \frac{1}{\sqrt{2\pi}} \int_{-\infty}^{x} exp( -\frac{t^2}{2} ) d t
x = -5:.1:5;
y_erf = erf(x); 
plot(x,y_erf)
title("误差函数 和 正态分布函数的累积分布函数(cdf)")

y_phi = normcdf(x)
hold on
plot(x,y_phi)

legend('误差函数(erf)', '正态分布的累积分布函数(cdf)')

hold off

% 利用erf函数求正态分布函数的 cdf
% mu: 正态分布的矩阵
% sigma: 正态分布的根方差
/* 这个函数被单独放在了 examples/normcdf.m 
function y = normcdf(x,mu,sigma)
	if(nargin == 1)
		mu = 0;
		sigma =1;
	end
	y = 1/2+1/2*erf( (x-mu)/(sqrt(2)*sigma) );
end
*/

