% 特殊函数 erf 函数的逆  erfinv
% erf(x)= \frac{2}{\sqrt{\pi}} \int_{0}^{x} exp(-t^2) d t 
% 积分下限是0，上限是x. 
% erfinv(x) 是上面函数的逆
% 误差函数从形式上很像正态分布的分布函数 \phi(x)
% 标准正态分布函数的分布函数 \phi(x) = \frac{1}{\sqrt{2\pi}} \int_{-\infty}^{x} exp( -\frac{t^2}{2} ) d t
% 可以通过 erfinv 来求\phi(x) 的逆 norminf
x = -5:.1:5;
y_erf = erf(x); 
y_erf_inv = erfinv(y_erf);
plot(y_erf,y_erf_inv)
title("误差函数的逆 和 正态分布函数的累积分布函数(cdf)的逆")

y_phi = normcdf(x);
y_phi_inv = norminv(y_phi);
hold on
plot(y_phi,y_phi_inv)

legend('误差函数(erf)', '正态分布的累积分布函数(cdf)')

hold off

% 利用erf函数求正态分布函数的 cdf 的逆
% mu: 正态分布的矩阵
% sigma: 正态分布的根方差
% 下面这个子函数被单独放在了 examples/norminv.m
/*
function y = norminv(x,mu,sigma)
	if(nargin == 1)
		mu = 0;
		sigma =1;
	end
	y =  (erfinv( 2*(x - 1/2) )   + mu) * sqrt(2)*sigma;
end
*/

