% A 做特征值分解，希望A矩阵是一个半正定对称矩阵
% 这样的他的特征值都大于或者等于0，在做了特征值分解后，
% 这个函数会将特征值按照从大到小排列 
% 相应的特征向量也做调整
% A = VV*DD*(VV)^(-1)
% A： 要分解的矩阵
% DD: A 的特征值构成的对角矩阵，特征值按照从大到小的顺序排列
% VV: 相应的特征向量
% 例:  A = rand(5);  [VV,DD] = sort_eig(A'*A)
function [VV,DD] = sort_eig(A)
	[V,D] = eig(A)
	d  = diag(D);
	[dd ,ii] = sort(d, 'descend') 
	DD = diag(dd);
	VV = V(:, ii);
end	
