%目前surf, surfc, mesh 等函数的绘图的局限性在于
% mesh(x,y,z) 实际上是把一个方块的区域剖分成矩形，
% 剖分虽然可以是不均匀的，但是一定是矩形
% 剖分点排列
% x = [  x0 x1 x2 
%         x0 x1 x2 
%         x0 x1 x2
%       ]
% y = [   y0 y0 y0 
%         y1 y1 y1 
%         y2 y2 y2 
%       ]
% z = [ z(x0,y0)  z(x1,y0) z(x2,y0)
%       z(x0,y1)  z(x1,y1) z(x2,y1)
%       z(x0,y2)  z(x1,y2) z(x2,y2)
%      ] 
% 下面这个例子，剖分的不是矩形，因此无法正确的画出图来。
[x,y,z]=get_xyz(-pi/2,0, 0, 2*pi, 20);
option = input("你想要用surfc画图吗(你可以看到surfc没有给出你想要的圆)\n ...
      1表示YES,其他表示No\n");
if(option == 1)
  surfc(x,y,z); 
else
% ~是占位符
[r,~]=size(x);
for i=1:r
plot3(x(i,:),y(i,:),z(i,:))
hold on
end
hold off
end

function [x,y,z] = get_xyz(ele0, ele1, azi0, azi1, n)
elevation=linspace(ele0,ele1, n);%仰角 一般是 (-pi/2,pi/2)
azimuth=linspace(azi0,azi1,n);%方位角 一般是(0,2*pi)
[azimuth,elevation]=meshgrid(azimuth,elevation);
x = cos(elevation).* cos(azimuth);
y = cos(elevation).* sin(azimuth);
z = sin(elevation);
end

