%支持向量机的例子
clear, clc, close all;

%生成数据, 并写到svmData.csv中, 数据有3列，第3列是标签
fid = fopen('svmData.csv','w+t')
for i=1:100
  fprintf(fid,"%6.4f,%6.4f,-1\n", -1+rand(), -1+rand()); 
  fprintf(fid,"%6.4f,%6.4f,1\n", 1+rand(), 1+rand()); 
end
fclose(fid);

%读入数据svmData.csv
data1=readmatrix('svmData.csv');
xx=zscore(data1(:,1:2));%标准化前两列的数据
yy=data1(:,end); %标签(取值是 1 或者-1)

total_size = size(data1,1);
train_size = floor( 7/10 * total_size);
X = xx(1:train_size,:);
y = yy(1:train_size,:);
test_X = xx(train_size+1:end,:);
test_y = yy(train_size+1:end,:);
C = 10;
svm = mysvmtrain(X, y, C, 'linear');
result = mysvmtest(svm, test_X, 'linear');
fprintf('Accuracy: %f\n', mean(result.y_pred == test_y));
%%训练结束，开始画图
x1_min = min(X(:, 1)) - 1;
x1_max = max(X(:, 1)) + 1;
x2_min = min(X(:, 2)) - 1;
x2_max = max(X(:, 2)) + 1;
[XX, YY] = meshgrid(x1_min:0.2:x1_max, x2_min:0.2:x2_max);
Z = mysvmtest(svm, [XX(:) YY(:)], 'linear');
Z = reshape(Z.y_pred, size(XX));
figure(1)
hold on;
plot(X(:, 1), X(:, 2), 'bo', 'MarkerFace', 'r');
title('Learning training set with linear kernel function');
xlabel('x1');
ylabel('x2');
legend('训练集');
hold off

figure(2)
mesh(XX,YY,Z);
title("一系列点上的预测值")

function y = zscore(x) 
  mean_value = mean(x); 
  std_value = std(x);
  y = zeros(size(x));
  len = size(x,2); 
  for i=1:len
    y(:,i) = ( x(:,i)-mean_value(i)) / std_value(i); 
  end
end
