%求解线性规划问题
% 这是一个运输问题(transportation problem)
%   三个仓库，两个商店
% 目标函数 f = x1+x2+x3+x4+x5+x6
% 约束
%  x1+x2 = 30 ; %第一个仓库的货物是30吨
%  x3+x4 = 70 ; %第二个仓库的货物是70吨
%  x5+x6 = 30;  %第三个仓库的货物是30吨
% x1+x3+x5 = 50; % 第一个商店需要的货物是50吨
% x2+x4+x6 = 80; % 第二哥商店需要的货物是80吨
% x1 x2 x3 x4 x5 x6 >= 0

load_plugin("optimization");

opts = struct();
opts.Display = 'off';
f = ones(1,6);
A = sparse([1 1 0 0 0 0 ; 0 0 1 1 0 0 ; 0 0 0 0 1 1; 1 0 1 0 1 0; ... 
  0 1 0 1 0 1 ]);
rl = [30,70,30, 50 , 80];
ru = rl; 
cl = zeros(6,1);
cu = [];
opts.Algorithm = 'interior-point';

[x, dr, dc, output] = linprog_hgs(f, A, rl, ru, cl, cu, opts)

