% tpdf函数 
% 用法:
% Y = tpdf(X,nu) % 

function y = tpdf(x, nu)
	if nargin < 1 
		x = -4:0.1:4;
	end

	if nargin < 2 
		nu = 1; 
	end

	if numel(nu) ~= 1
    error("nu 需要是正整数");
	end

  y = gamma( (nu+1)/2 ) ./ gamma( nu/2 ) .* (1/sqrt(nu*pi)) ./ (1+x.^2 ./nu).^( (nu+1)/2); 
end  

