/**
例4-74  某车间用一台包装机包装葡萄糖，包得的袋装糖重是一个随机变量，
它服从正态分布。当机器正常时，其均值为0.5公斤，标准差为0.015。
某日开工后检验包装机是否正常，随机地抽取所包装的糖9袋，
称得净重为（公斤）
0.497,  0.506,  0.518,  0.524,  0.498,  0.511,  0.52,  0.515,  0.512
问机器是否正常？
解：总体μ和σ已知，该问题是当为\sigma已知时，在水平alpha =0.05下，
根据样本值判断μ=0.5还是显著。为此提出假设：
原假设：\mu = 0.5  
备择假设： \mu \neq 0.5

>> X=[0.497,0.506,0.518,0.524,0.498,0.511,0.52,0.515,0.512];
>> [h,sig,ci,zval]=ztest(X,0.5,0.015,0.05,0)
结果显示为
h =
     1
sig =
    0.0248       %样本观察值的概率
ci =
    0.5014    0.5210        %置信区间，均值0.5在此区间之外
zval =
    2.2444       %统计量的值
结果表明：h=1，说明在水平下，可拒绝原假设，即认为包装机工作不正常。
*/

总体_sigma = 0.015;  %检查总体的标准差;
显著性水平_alpha = 0.05; % 显著性水平
总体均值_mu = 0.5 ; % 检测总体的均值 ; 

X=[0.497,0.506,0.518,0.524,0.498,0.511,0.52,0.515,0.512]; %样本

tail = 0; % 使用双侧检验 
[h,sig,ci,zval]=ztest(X, 总体均值_mu , 总体_sigma, 显著性水平_alpha ,tail) ; %双侧检验 'both' 
%调用ztest函数作总体均值的双侧检验
%返回变量h，检验的p值，均值的置信区间muci,检验统计量的观测值zval
x=-4:0.1:4; 
p = normpdf(x,0,1); %正态分布的概率密度
plot(x,p,'color','k')
title("正态分布概率密度函数")
xlabel("z")
ylabel("概率密度")
hold on
x0 = norminv(1- 显著性水平_alpha/2); 
line( [x0, x0],[0, 0.15])
text(x0+0.8, 0.01, "P(Z <= 1.96) = 0.975",'color','r')

line( [-x0, -x0],[0, 0.15])
text(-x0-0.8, 0.01, "P(Z <= -1.96) = 0.025",'color','r')

fill( [-x0, x0, x0, -x0] , [0, 0, 0.02,0.02], 'b')
text(0,0.04, "P( |Z| < 1.96 ) = 0.95",'color','b')

hold off
