%如果令 X = 0.5*ones(9,1)
% 那么得到的结果是
% 样本均值是 0.5000, 拒绝假设 均值 \mu < 0.5000
%假设成立的概率是 0.5000, 样本均值mu的1-alpha置信区间是[0.4918,   inf]
%样本均值是 0.5000, 拒绝假设 均值 \mu > 0.5000
%假设成立的概率是 0.5000, 样本均值mu的1-alpha置信区间是[  -inf,0.5082]
%样本均值是 0.5000, 接受假设 均值 \mu == 0.5000
%假设成立的概率是 1.0000, 样本均值mu的1-alpha置信区间是[0.4902,0.5098]

X=0.5+randn(30,1)*0.015 - 10;


% 如果h=1, 则表示要以显著性水平a下接受假设H0: \mu >= \mu0, 拒绝备择假设 H1: 均值\mu < mu0
alpha = 0.05;
mu0 = 0.5;
[h,sig,ci,zval]=ztest(X,0.5,0.015,0.05,'left');
if h
	fprintf("样本均值是 %6.4f, 拒绝假设 均值 \mu > %6.4f\n", mean(X), mu0);  
else
	fprintf("样本均值是 %6.4f, 接受假设 均值 \mu > %6.4f\n", mean(X), mu0);  
end
	fprintf("假设成立的概率是 %6.4f, 样本均值mu的1-alpha置信区间是[%6.4f,%6.4f]\n", sig, ci(1),ci(2));  

% 如果h=1, 则表示要以显著性水平a下接受假设H0: \mu <= \mu0, 拒绝备择假设 H1: 均值\mu > mu0
alpha = 0.05;
mu0 = 0.5;
[h,sig,ci,zval]=ztest(X,0.5,0.015,0.05,'right');
if h
	fprintf("样本均值是 %6.4f, 拒绝假设 均值 \mu < %6.4f\n", mean(X), mu0);  
else
	fprintf("样本均值是 %6.4f, 接受假设 均值 \mu < %6.4f\n", mean(X), mu0);  
end
	fprintf("假设成立的概率是 %6.4f, 样本均值mu的1-alpha置信区间是[%6.4f,%6.4f]\n", sig, ci(1),ci(2));  


% 如果h=1, 则表示要以显著性水平a下接受假设H0: \mu = \mu0,  选择备择假设 H1: 均值\mu \neq mu0
alpha = 0.05;
mu0 = 0.5;
[h,sig,ci,zval]=ztest(X,0.5,0.015,0.05,'both');
if h
	fprintf("样本均值是 %6.4f, 拒绝假设 均值 \mu == %6.4f\n", mean(X), mu0);  
else
	fprintf("样本均值是 %6.4f, 接受假设 均值 \mu == %6.4f\n", mean(X), mu0);  
end
	fprintf("假设成立的概率是 %6.4f, 样本均值mu的1-alpha置信区间是[%6.4f,%6.4f]\n", sig, ci(1),ci(2));  


